/**
 ** TEST.C
 **
 **  Copyright (C) 1992, Csaba Biegl
 **    820 Stirrup Dr, Nashville, TN, 37221
 **    csaba@vuse.vanderbilt.edu
 **
 **  This file is distributed under the terms listed in the document
 **  "copying.cb", available from the author at the address above.
 **  A copy of "copying.cb" should accompany this file; if not, a copy
 **  should be available from where this file was obtained.  This file
 **  may not be distributed without a verbatim copy of "copying.cb".
 **  You should also have received a copy of the GNU General Public
 **  License along with this program (it is in the file "copying");
 **  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 **  Cambridge, MA 02139, USA.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **/


#include "test.h"
#include <time.h>



TESTFUNC(test1)
{
	long x,y;
	int  ii,results[16],res2[16];
	GrContext *xxx;

	x = time(NULL);
	y = 0L;
	while(!kbhit()) {
	    GrClearScreen(GrWhite());
	    GrClearScreen(GrBlack());
	    y++;
	}
	x = time(NULL) - x;
	sprintf(exit_message,"%ld screen writes in %ld seconds, transfer rate = %ld Kbytes/sec\n",
	    y,
	    x,
	    (x == 0L) ?
		0L :
		((long)GrSizeX() * (long)GrSizeY() * y) /
		    (x * 1000L) /
		    ((GrNumColors() < 256) ? 8 : 1)
	);
	getkey();
	drawing(0,0,GrSizeX(),GrSizeY(),GrWhite(),GrBlack());
	getkey();
	GrClearScreen(GrBlack());
	xxx = GrCreateContext(100,100,NULL,NULL);
	for(ii = 0; ii < 16; ii++) {
	    GrPlot(100+5*ii,100,ii);
	    results[ii] = GrPixel(100+5*ii,100);
	    GrBitBlt(xxx,3+ii,1,NULL,100+5*ii,100,100+5*ii,100,GrWRITE);
	    GrSetContext(xxx);
	    res2[ii] = GrPixel(3+ii,1);
	    GrSetContext(NULL);
	}
	getkey();
	GrSetMode(GR_default_text);
	for(ii = 0; ii < 16; ii++) {
	    printf("written pixel: 0x%02x, read back 0x%02x (0x%02x)\n",
		ii,
		results[ii],
		res2[ii]
	    );
	}
	getkey();
}

